
#include <stdio.h>
#include <cmath>
#include <vector>

#if 0
template <class type>
  type max( type a, type b )
  {
    return a > b ? a : b;
  }

template <class type>
  type min( type a, type b )
  {
    return a < b ? a : b;
  }
template <class type>
  unsigned long long round_m( type a )
  {
    if ((unsigned long long)(a * 10) % 10 > 0)
      return (unsigned long long)a + 1;
    return (unsigned long long)a;
  }

template <class type>
  bool in( type mi, type ma, type cur )
  {
    if (cur >= mi && cur <= ma)
      return 1;
    return 0;
  }

template <class type>
  bool near( type a, type b, type delta )
  {
    return a > b ? (a - b <= delta) : (b - a <= delta);
  }
#endif // 0
template <class type>
  class queue
  {
  private:
    class list
    {
    private:
      class list_item
      {
      public:
        list_item *Next;
        type Data;

        list_item( const type &D, list_item *N = nullptr ) : Next(N), Data(D)
        {
        } // End of 'list_item' function
      }; // End of 'list_item' class
      list_item *Head = nullptr;
      list_item *Tail = nullptr;

    public:
      ~list( void )
      {
        list_item *c = Head, *n;
        while (c != nullptr)
        {
          n = c->Next;
          delete c;
          c = n;
        }
      } // End of '~list' class

    }; // End of 'list' class
  public:
    list Lst;

    void Put( const type &D )
    {
      if (Lst.Head == nullptr)
      {
        Lst.Head = Lst.Tail = new list_item(D);
        return;
      }
      list_item *i = new list_item(D);
      Lst.Tail->Next = i;
      Lst.Tail = i;
    }
    type Get( void )
    {
      if (Lst.Head == nullptr)
        throw std::exception("empty list");
      list_item *i = Lst.Head;
      Lst.Head = Lst.Head->Next;
      type r = i.Data;
      delete i;
      return r;
    }
  }; // End of 'queue' class

void main( void )
{
  int n, m;
  
  scanf("%i %i", &n, &m);

  if (n == 1)
  {
    int t, a;
    scanf("%i %i", &t, &a);
    printf("%i", (a - 1) * 2 + t);
    return;
  }

  // n != 1
  int *t   = new int[n];
  int *a   = new int[n];
  int *res = new int[n];
  memset(res, -1, sizeof(int) * n);
  std::vector<int> *w8ing = new std::vector<int>[m + 1];
  std::vector<int> inside;
  // read workers
  for (int i = 0; i < n; i++)
    scanf("%i %i", t + i, a + i);
  // queue<int> targets;
  std::vector<int> targets;

  int left = n, cur_time = 0;
  int floor = 1, target = 1;
  // main loop
  while (left > 0)
  {
    // update targets
    for (int i = 0; i < n; i++)
      if (t[i] == cur_time && res[i] == -1)
      {
        bool cont = 0;
        for (int j = 0; j < inside.size() && !cont; j++)
          if (inside[j] == i)
            cont = 1;
        if (cont)
          continue;
        targets.push_back(a[i]);
        w8ing[a[i]].push_back(i);
      }
    if (target > floor)
      floor++;
    else if (target < floor)
    {
      floor--;
      // update elevator & floor info
      for (int i = 0; i < w8ing[floor].size(); i++)
        inside.push_back(w8ing[floor][i]);
      w8ing[floor].clear();
      // clear targets
      for (int i = 0; i < targets.size(); i++)
        if (targets[i] == floor)
          targets[i] = -1;
    }
    if (floor == target)
    {
      if (floor == 1)
      {
        for (int i = 0; i < inside.size(); i++)
          res[inside[i]] = cur_time;
        left -= inside.size();
        inside.clear();
        // clear targets
        for (int i = 0; i < targets.size(); i++)
          if (targets[i] == floor)
            targets[i] = -1;
        // find next target
        for (int i = 0; i < targets.size(); i++)
        {
          if (targets[i] == -1)
            continue;
          target = targets[i];
          targets[i] = -1;
          break;
        }
      }
      else // if (floor == 1)
      {
        for (int i = 0; i < w8ing[floor].size(); i++)
          inside.push_back(w8ing[floor][i]);
        w8ing[floor].clear();
        target = 1;
      } // End of "(else)if (floor == 1)"
    } // End of "if (floor == target)"
    cur_time++;
  } // End of 'main llop'

  // print answer
  for (int i = 0; i < n; i++)
    printf("%i\n", res[i]);

  // cleanup
  delete[] t;
  delete[] a;
  delete[] res;
  delete[] w8ing;
}
