// Kirill Prokopenko

#include <stdio.h>
#include <windows.h>
#include <cmath>
#include <vector>

class tree_elem
{
public:
  std::pair<DWORD, DWORD> Lens;
  std::vector<DWORD> Child;
  DWORD best;
  DWORD answer4m1;

  VOID FillLens( VOID );
};

std::vector<tree_elem> Tree;

VOID tree_elem::FillLens( VOID )
{
  if (Child.size() == 0)
  {
    Lens = std::pair<DWORD, DWORD>(1, 1);
    answer4m1 = 1;
    return;
  }
  DWORD b1 = 0, b2 = 0;
  answer4m1 = 0;
  for (INT i = 0; i < Child.size(); i++)
  {
    Tree[Child[i]].FillLens();
    DWORD m = max(Tree[Child[i]].Lens.first, Tree[Child[i]].Lens.second);
    answer4m1 = max(answer4m1, Tree[Child[i]].answer4m1);
    if (m > b1)
      b2 = b1, b1 = m;
    else
      if (m > b2)
        b2 = m;
  }
  Lens.first = b1 + 1;
  Lens.second = (b2 == 0) ? 0 : b2 + 1;
  best = b1;
  answer4m1 = max(answer4m1, b1 + b2 + 1);
}

VOID main( INT argc, CHAR *argv[] )
{
  DWORD n, m;

  scanf("%u %u", &n, &m);
  Tree.resize(n);
  // 0 -root
  for (INT i = 1; i < n; i++)
  {
    DWORD t;
    scanf("%u", &t);
    Tree[t - 1].Child.push_back(i);
  }
  Tree[0].FillLens();
  printf("%u", Tree[0].answer4m1 + 2 * (Tree[0].best + 1) * (m - 1));
}

// END OF 'main.cpp' FILE
